// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include "ISCW_UK2Node_FunctionTerminator.h"
#include "SCW_UK2Node_EditablePinBase.h"

class UK2Node_FunctionTerminator;

namespace Sourcify
{
	class SCW_UK2Node_FunctionTerminator : public SCW_UK2Node_EditablePinBase, public virtual ISCW_UK2Node_FunctionTerminator
	{
	public:
		SCW_UK2Node_FunctionTerminator(UK2Node_FunctionTerminator* InK2Node_FunctionTerminator);

		ISCW_UFunctionPtr FindSignatureFunction() const override;

		ISCW_FMemberReferencePtr GetFunctionReference() const override;
			
		UK2Node_FunctionTerminator* ToUK2Node_FunctionTerminator() const;

	protected:
		UK2Node_FunctionTerminator* K2Node_FunctionTerminator;
	};
} // namespace Sourcify